//=========================================================================
__CONFIG(1, OSCSEN & HS);
__CONFIG(2, PWRTEN & BORV20 & BOREN & WDTDIS & WDTPS128);
__CONFIG(4, DEBUGDIS & LVPDIS & STVREN);
__CONFIG(5, UNPROTECT);
__CONFIG(6, WPU);
__CONFIG(7, PTBRU);

////////////////////////////////////////////////////////////
#define VCAL			0.169	//  .  
#define PRCAL			1.37	//  .  
#define PRFORS			185		//  
#define CNTFORS			4		//  
#define TEMPCAL			4.092	//  

#define SendUART(a)		{while(!TRMT){};TXREG=a;}
#define baud			19200		// define USART baud rate
#define	_XTAL_FREQ		(20000000L) //   
#define i2c_bus_rate	(100000L)	// define I2C bus rate
#define i2c_start()		{SEN=1;while(SEN){}}
#define i2c_stop()		{PEN=1;while(PEN){}}
#define i2c_restart()	{RSEN=1;while(RSEN){}}
#define i2c_write(a)	{SSPBUF=a;while((SSPCON2&0x1F)||RW){}}

#define LCD_ADDR	(0x78)// 3
#define DISP		(0b01000000) //   
#define COM			(0b10000000) //  

#define	DelayUs(x)	{ unsigned char _dcnt; \
			  if(x>=4) \
				_dcnt=(x*(_XTAL_FREQ/4000000L)/5); \
			  else \
				_dcnt=1; \
			  while(--_dcnt > 0){ \
					asm("bra $+1");\
					continue;\
			  }\
			}

///////////    /////////////////////
static volatile bit	Key		@ (unsigned)&PORTB*8+2; // .
static volatile bit	Zag		@ (unsigned)&PORTB*8+1; //  ""+.
static volatile bit	ResLCD	@ (unsigned)&LATC*8+5; //  .

//#####################################################################################
unsigned long
	AccOpen,	//      
	NOpen,		//   
	FOpen,		//        F
	DOpen,		//       
	Sav_FOpen,	//       
	Sav_NOpen,	//   
	VBar,		//   
	TmpLong,	//    Lo
	TmpLong2;	//    Lo

unsigned int 
	Sav_EBar,	//   
	SpFuel,		//  - /
	TempAmbient,//  
	TempCabin,	//   
	VAkk,		//  
	TmpInt;		//     

signed int
	TmpSInt;	//     

unsigned char
	BLcd[5],	//    
	CountPrc,	//    
	CountTemp,	//    
	VCnt,		//      
	TmpChar;	//     

volatile struct {
	unsigned 	PrKey:1;	//     
	unsigned 	KShort:1;	//   
	unsigned 	KLong:1;	//   
	unsigned 	PrZ:1;		//     
	unsigned 	Zon:1;		//   
	unsigned 	Zoff:1;		//   
	unsigned 	Minus:1;	//  
} flag;	// 

volatile struct {
	unsigned 	Temp:1;		//   
	unsigned 	Fuel:1;		//   
	unsigned 	Volt:1;		//   
} Lcd;	//  LCD

//#####################################################################################
void lcd_init(void); //  LCD
void lcd_clear(void); //   
void lcd_gotoxy(unsigned char x,unsigned char y); //   
void lcd_putch(unsigned char c);
void lcd_Bar(unsigned char c);
void lcd_printROM(const unsigned char *s); //    s  ,
void lcd_printRAM(unsigned char *s); //   s  ,
void IntToStrBCD(signed int value); //    
void DelayMs(unsigned char cnt);



//===================================================================
union {
	float			F;
	unsigned long	L;
	unsigned int	I[2];
	unsigned char	C[4];
	struct {
		unsigned b0:1;
		unsigned b1:1;
		unsigned b2:1;
		unsigned b3:1;
		unsigned b4:1;
		unsigned b5:1;
		unsigned b6:1;
		unsigned b7:1;
		unsigned b8:1;
		unsigned b9:1;
		unsigned b10:1;
		unsigned b11:1;
		unsigned b12:1;
		unsigned b13:1;
		unsigned b14:1;
		unsigned b15:1;
		unsigned b16:1;
		unsigned b17:1;
		unsigned b18:1;
		unsigned b19:1;
		unsigned b20:1;
		unsigned b21:1;
		unsigned b22:1;
		unsigned b23:1;
		unsigned b24:1;
		unsigned b25:1;
		unsigned b26:1;
		unsigned b27:1;
		unsigned b28:1;
		unsigned b29:1;
		unsigned b30:1;
		unsigned b31:1;
	}B;
} Val; //    long, int, char, bit
//	Val.F = 1.0;
//	Val.L = 1;
//	Val.I[0] = 2;
//	Val.C[0] = 3;
//	Val.B.b2 = 1;


